<script>
export default {
  name: "Share",
  mounted() {
    this.$nextTick(() => {
      this.simulateLoading()
    })
  },
  data() {
    return {
      totalProgress: 100,
      progress: 0,
      form: {
        title: '比亚迪海豹',
        size: '15.6英寸',
        texture: 'OLED中控屏',
        chip: '高通骁龙690 芯片',
        storage: '24G/256G',
        version: 'V21.1.2.2208610.1',
        voice: '你好，小迪'
      },
      isMask: false
    }
  },
  methods: {
    simulateLoading() {
      const progressBar = this.$refs.progress;
      const chunkSize = 20;
      const numChunks = this.totalProgress / chunkSize;

      const interval = setInterval(async () => {
        this.progress++;

        const progress = (this.progress / numChunks) * this.totalProgress;
        progressBar.style.width = progress + '%';

        const promises = [];
        for (let i = 0; i < chunkSize; i++) {
          promises.push(import('./icons'));
        }

        await Promise.all(promises);

        if (progress >= this.totalProgress) {
          setTimeout(() => {
            this.isMask = true;
          }, 600)
          clearInterval(interval);
        }
      }, 500);
    },
    handleRouter() {
      if (this.progress >= 5) this.$router.push('/home')
    },
    handleShare() {
      window.AHAPP.invokeNative('h5share', {
        // platform: 'weixin&weixincircle&weibo&qq&qqzone', // 分享平台，all 为所有支持的平台
        platform: 'all',
        url: 'https://z.autoimg.cn/car_engine/byd-haibao/index.html',
        title: '比亚迪海豹 车机体验', // 标题
        content: '车机多媒体体验，尽在汽车之家', // 描述信息
        imgurl: 'https://z.autoimg.cn/serieshighlights/cheji/Q4-1/haibao.jpg',
      });
    }
  }
}
</script>

<template>
  <div class="share-main">
    <div class="top"></div>
    <div class="bottom"></div>
    <div class="left"></div>
    <div class="right"></div>
    <img class="img-1" src="./assets/img.webp" alt="" />
    <div v-if="isMask" class="img-hand" @click="handleRouter">
      <img src="./assets/images/hand.webp" alt="">
      <p>点击屏幕深度体验</p>
    </div>

    <div class="icon-share flex flex-jcs flex-center">
      <img class="svg-icon" src="./assets/images/back_share.webp" alt="" />
    </div>
    <div class="middle"  @click.stop="handleRouter">
      <div class="title">{{ form.title }}</div>

      <div class="text-box">
        <div class="text flex flex-column">
          <div>{{ form.size }}</div>
          <div>屏幕尺寸</div>
        </div>
        <div class="text flex flex-column">
          <div>{{ form.texture }}</div>
          <div>屏幕材质</div>
        </div>
        <div class="text flex flex-column">
          <div>{{ form.chip }}</div>
          <div>车机芯片</div>
        </div>
        <div class="text flex flex-column">
          <div>{{ form.storage }}</div>
          <div>RAM/ROM</div>
        </div>
        <div class="text flex flex-column">
          <div>{{ form.version }}</div>
          <div>车机系统</div>
        </div>
        <div class="text flex flex-column">
          <div>{{ form.voice }}</div>
          <div>语音助手</div>
        </div>
      </div>

      <div class="share-button flex" @click.stop="handleShare">
        <img class="svg-icon" src="./assets/images/icon_share.webp" alt="" />
        <div>分享</div>
      </div>
    </div>
    <div class="progress-body flex flex-column w-full">
      <div class="text flex flex-jcs">
        <div>正在加载</div>
        <div>loading... {{ Math.min((progress * 20), 100) + '%' }}</div>
      </div>
      <div class="progress-bar">
        <div class="progress" ref="progress"></div>
      </div>
    </div>
  </div>
</template>

<style scoped lang="scss">
.share-button {
  margin-top: 40px;
  width: 360px;
  height: 90px;
  box-sizing: border-box;
  padding: 10px 45px;
  justify-content: center;
  align-items: center;
  border-radius: 10px;
  opacity: 1;
  background: #3D4759;
  color: #FFFFFF;
  font-size: 36px;
  line-height: 10px;
  z-index: 6;

  .svg-icon {
    width: 32px;
    height: 32px;
  }

  img {
    margin-right: 10px;
  }
}
.share-main {
  width: 100%;
  height: 100%;
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  background: #101D33;
  background-image: url("../src/assets/images/img.webp");
  background-repeat: no-repeat;
  background-position: 300px;
  background-size: 100% 100%;

  .left {
    position: absolute;
    top: 0;
    left: 0;
    width: 1430px;
    height: 100%;
    background: linear-gradient(101deg, #101D33 4%, #101D33 23%, #101D33 39%, rgba(16, 29, 51, 0.94) 49%, rgba(16, 29, 51, 0.87) 56%, rgba(16, 29, 51, 0.83) 61%, rgba(16, 29, 51, 0.76) 65%, rgba(16, 29, 51, 0.69) 69%, rgba(16, 29, 51, 0.58) 75%, rgba(16, 29, 51, 0.48) 78%, rgba(16, 29, 51, 0.33) 81%, rgba(16, 29, 51, 0.2) 84%, rgba(16, 29, 51, 0) 87%);
    z-index: 1;
  }
  .right {
    position: absolute;
    right: 0;
    top: 0;
    width: 300px;
    height: 100%;
    background: linear-gradient(270deg, rgba(0, 0, 0, 0.74) 0%, rgba(0, 0, 0, 0.37) 40%, rgba(0, 0, 0, 0) 88%);
    z-index: 1;
  }
  .top {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 300px;
    background: linear-gradient(180deg, rgba(0, 0, 0, 0.94) 1%, rgba(0, 0, 0, 0.59) 50%, rgba(0, 0, 0, 0) 100%);
    z-index: 1;
  }
  .bottom {
    position: absolute;
    bottom: 0;
    left: 0;
    width: 100%;
    height: 300px;
    background: linear-gradient(180deg, #000000 0%, rgba(0, 0, 0, 0.67) 50%, rgba(0, 0, 0, 0) 100%);
    z-index: 1;
    transform: rotate(180deg);
  }
  .img-1 {
    position: absolute;
    right: 125px;
    top: 180px;
    width: 1400px;
    object-fit: cover;
  }
  .bg-mask{
    position: absolute;
    width: 100%;
    height: 100%;
    opacity: 0.4;
    background: #000000;
    z-index: 3;
  }
  .img-hand {
    position: absolute;
    left: 40%;
    top: 40%;
    transform: translate(-50%, -50%);
    z-index: 3;
    animation: hand .6s infinite alternate;
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
    img {
      width: 200px;
      object-fit: contain;
    }
    p {
      margin-top: 50px;
      font-weight: 500;
      font-size: 36px;
      color: #F9F9F9;
      white-space: nowrap;
    }
  }

  .middle {
    flex: 1;
    z-index: 2;
    padding-left: 100px;
    box-sizing: border-box;
    .title {
      color: #fff;
      font-size: 90px;
      margin-top: 50px;
    }
    .text-box {
      margin-left: 20px;
      width: 1000px;
      display: grid;
      grid-template-columns: 1fr 1fr;
      grid-column-gap: 50px;
      color: #FFFFFF;
      .text {
        div:first-child {
          margin-top: 40px;
          margin-bottom: 18px;
          font-size: 44px;
        }
        div:last-child {
          font-size: 34px;
        }
      }
    }
  }

  .icon-share {
    height: 83px;
    padding: 40px 80px;
    z-index: 4;

    .svg-icon {
      width: 66px !important;
      height: 66px !important;
    }
  }
}

.progress-body {
  z-index: 2;
  margin-bottom: 58px;
  color: #fff;
  padding: 0 80px;
  box-sizing: border-box;

  .text {
    font-size: 30px;
  }
}
.progress-bar {
  margin-top: 15px;
  width: 100%;
  height: 20px;
  background: rgba(255, 255, 255, 0.16);
  overflow: hidden;

  .progress {
    width: 0%;
    height: 100%;
    background-color: #0088FF;
    transition: width 0.5s ease-in-out;
  }
}
@keyframes hand{
  0%{
    transform: scale(1);
  }
  100%{
    transform: scale(0.7);
  }
}
</style>